#version 330
#extension GL_ARB_separate_shader_objects : enable





layout(location = 0) smooth in vec2 _fin_fragTexCoord;

struct SFragmentInput
{
	vec2 fragTexCoord;
	bool IsFrontFace;
};

layout(location = 0) out vec4 _fout_outColor;

struct SFragmentOutput
{
	vec4 outColor;
};

 uniform sampler2D Texture;
 uniform sampler2D LookUp;

layout( std140) uniform UDistortionInfo
{
	vec4 DistortionMultipliers;
} DistortionInfo;



void FragmentMain( in SFragmentInput  fInput,  out SFragmentOutput  fOutput  )
{

	vec4 distoApply =  texture(LookUp, fInput.fragTexCoord) ;

	vec4 distortionMultipliers =  DistortionInfo.DistortionMultipliers ;


	vec4 color0 =  texture(Texture, fInput.fragTexCoord + distoApply.xy * distortionMultipliers.x)  * vec4(0.5, 0.0, 0., 0.0);
	vec4 color1 =  texture(Texture, fInput.fragTexCoord + distoApply.xy * distortionMultipliers.y)  * vec4(0.5, 0.5, 0., 0.5);
	vec4 color2 =  texture(Texture, fInput.fragTexCoord + distoApply.xy * distortionMultipliers.z)  * vec4(0.0, 0.5, 0., 0.5);
	vec4 color3 =  texture(Texture, fInput.fragTexCoord + distoApply.xy * distortionMultipliers.w)  * vec4(0.0, 0.0, 1., 0.0);

	fOutput.outColor = color0 + color1 + color2 + color3;
}


void main()
{
	SFragmentInput fInput;
	SFragmentOutput fOutput;

	fInput.fragTexCoord = _fin_fragTexCoord;
	fInput.IsFrontFace = gl_FrontFacing;
	FragmentMain(fInput, fOutput);
	_fout_outColor = fOutput.outColor;
}
